(*******************************************************************
This file was generated automatically by the Mathematica front end.
It contains Initialization cells from a Notebook file, which
typically will have the same name as this file except ending in
".nb" instead of ".m".

This file is intended to be loaded into the Mathematica kernel using
the package loading commands Get or Needs.  Doing so is equivalent
to using the Evaluate Initialization Cells menu command in the front
end.

DO NOT EDIT THIS FILE.  This entire file is regenerated
automatically each time the parent Notebook file is saved in the
Mathematica front end.  Any changes you make to this file will be
overwritten.
***********************************************************************)











(*  TMecanica is a Mathematica package that needs the package Tensorial 3.0  *)

(*  Author: Renan Cabrera   *)

(*  rencabla@ceibo.entelnet.bo / renanbo@hotmail.com *)

(*  I would appreciate any comments and your contributions are welcome to \
become part of TMecanica. *)

(* TMecanica can be used and distributed freely, for non commercial purpose, 
always mentioning the author every time used as specified at Mathsource \
(www.mathsource.com)

 This software package and its accompanying documentation are provided \
without 
 guarantee of support or maintenance *)

(*  Mathematica is a registered trademark of Wolfram Research, Inc.     *)



BeginPackage["TMecanica1`TMecanica`",{"Graphics`Colors`",
    "TensorCalculus3`Tensorial`"}]



PoissonB::usage=" PoissonB[G,W], represents the Poisson Bracket of G and W ";

ExpandPoissonB::usage=
    "ExpandPoissonB[{x, \[Delta], g, \[CapitalGamma]}, J, {\[Mu],\[Nu]}, \
flavor:Identity][expr] expands the Poisson brackets in a system with labels \
{x,\[Delta],g,\[CapitalGamma]}, Symplectic matrix label J and dummy variables \
{\[Mu],\[Nu]} using the given flavor which has the default value of Identity \
for plain.";

FullExpandPoissonB::usage=
    "FullExpandPoissonB[{x, \[Delta], g, \[CapitalGamma]}, J, \
flavor:Identity][expr] fully expands the Poisson Bracket in a system with \
labels {x,\[Delta],g,\[CapitalGamma]}, and symplectic matrix label J using \
the given flavor which has the default value of Identity for plain.";

SetSymplecticJValues::usage=
    "SetSymplecticJValues[J, dim, flavor:Identity] sets the values of the \
tensor object of label J  to the symplectic values in a space of dimension \
dim. The default flavor is plain, specified by Identity. dim must be a \
positive even integer.";

SetSymplecticJValueRules::usage=
    "SetSymplecticJValueRules[J, dim, flavor:Identity] sets value rules for \
the tensor object of label J  to the symplectic values in a space of \
dimension dim. The default flavor is plain, specified by Identity. dim must \
be a positive even integer.";

TOperator::usage=
    "TOperator[G, \[Epsilon], n][W] gives the nth order expansion of the \
operator T of the accumulative effect of infinitesimal canonical \
transformations generated by G in the parameter \[Epsilon]. If G is the \
Hamiltonian, the operator T is the evolution operator. \n
Both G and W must be tensor objects.\n 

This routine returns an expression with Hold. Use the rule Hold \[Rule] \
Identity to obtain full evaluation.";


InverseTOperator::usage=
    "InverseTOperator[G, \[Epsilon], n][W] gives the nth order expansion of \
the inverse operator T of the accumulative effect of infinitesimal canonical \
transformations generated by G in the parameter \[Epsilon]. If G is the \
Hamiltonian, the operator T is the evolution operator. \n
Both G and W must be tensor objects.\n 

This routine returns an expression with Hold. Use the rule Hold \[Rule] \
Identity to obtain full evaluation.";


ExpandedTOperator::usage=
    "ExpandedTOperator[{x, \[Delta], g, \[CapitalGamma]}, J, G, \[Epsilon], \
n][W] gives the nth order expansion of the operator T of the accumulative \
effect of infinitesimal canonical transformations generated by G  in the \
parameter \[Epsilon]. The difference with TOperator is that here the \
expansion is fully evaluated and we assume that G does not depend on the \
expansion parameter \[Epsilon], which is useful for most of the intersting \
cases. Be carefull not to apply this expansion to generators expanded in a \
perturbative series because in this case the perturbation parameter appears \
explicitly in the whole generator.\n
";

InverseTOperatorPerturbationExpansion::usage=
    "InverseTOperatorPerturbationExpansion[G, W, n] will create a \
perturbative series expansion of the inverse transformation operator with \
generators of label G, applied to a tensor W in terms of the parameter \
\[Epsilon]. \nThe original series expansion are of nth order.";

GeneratorPerturbationExpansion::usage=
    "GeneratorPerturbationExpansion[G, \[Epsilon], n] will create a nth order \
perturbative series expansion for the generator of label G. This series \
expansion is meant only for the generator of the transformation operator.";

TOperatorPerturbationExpansion::usage=
    "TOperatorPerturbationExpansion[G, W, n] will create a perturbative \
series expansion of the transformation operator with generators of label G, \
applied to a tensor W in terms of the parameter \[Epsilon]. \nThe original \
series expansion are of nth order.";

HamiltonianPerturbationExpansion::usage=
    "HamiltonianPerturbationExpansion[K, \[Epsilon], n] will create an nth \
order perturbative series expansion for the new Hamiltonian with label K in \
the parameter \[Epsilon].";

ExtractSeriesTerm::usage=
    "ExtractSeriesTerm[\[Epsilon], n][expr] gets the nth order expansion of \
expr if the series is collected in terms of \[Epsilon]";



Begin["`Private`"]

Format[PoissonB[G_,W_]]:= {G,W};


PoissonB/:HoldPattern[PartialD[lab_][PoissonB[G_,W_],s_]]:=
    PoissonB[G,PartialD[lab][W,s] ]+PoissonB[PartialD[lab][G,s] ,W];

HoldPattern[PoissonB[A_,B_*C_]]:=PoissonB[A,B]*C + B*PoissonB[A,C];

HoldPattern[PoissonB[B_*C_,A_]]:=PoissonB[B,A]*C + B*PoissonB[C,A];

HoldPattern[
        PoissonB[A_,B_]]/;(Position[A,Tensor]==={}||Position[B,Tensor]==={}):=
    0;

HoldPattern[PoissonB[G_,W_Plus]]:=Map[PoissonB[G,#]&,W];
HoldPattern[PoissonB[G_Plus,W_]]:=Map[PoissonB[#,W]&,G];


ExpandPoissonB[{x_,\[Delta]_,g_,\[CapitalGamma]_},J_,{\[Mu]_,\[Nu]_},
        flavor_:Identity][Q_]:= Module[{xu,i},
      xu[i_]=Tensor[x,{i},{Void}];
      Q/.HoldPattern[PoissonB[W_,G_]]:>
          PartialD[{x,\[Delta],g,\[CapitalGamma]}][W,xu[flavor@\[Mu]]]Tensor[
              J,flavor/@{\[Mu],\[Nu]},{Void,
                Void}]PartialD[{x,\[Delta],g,\[CapitalGamma]}][G,
              xu[flavor@\[Nu]]]
      ];

FullExpandPoissonB[{x_,\[Delta]_,g_,\[CapitalGamma]_},J_,flavor_:Identity][
      Q_]:= Module[{G,W,dum},
      dum=
        Q//.HoldPattern[PoissonB[W_,G_]]:>
            ExpandPoissonB[{x,\[Delta],g,\[CapitalGamma]},
                J,{Unique[\[Mu]],Unique[\[Nu]]},flavor][PoissonB[W,G]];
      EinsteinSum[][dum]
      ];



SetSymplecticJValues[J_,dim_Integer?(EvenQ[#]\[And]Positive[#]&),
      flavor_:Identity]:=Module[{k},
      J1=Inner[Join,k@@Table[0,{dim/2},{dim/2}],k@@IdentityMatrix[dim/2],
          List];
      J2=Inner[Join,k@@(-IdentityMatrix[dim/2]),k@@Table[0,{dim/2},{dim/2}],
          List];
      SetTensorValues[
        Tensor[J,flavor/@{Global`\[Mu],Global`\[Nu]},{Void,Void}],
        Join[J1,J2]]
      ];

SetSymplecticJValueRules[J_,dim_Integer?(EvenQ[#]\[And]Positive[#]&),
      flavor_:Identity]:=Module[{k},
      J1=Inner[Join,k@@Table[0,{dim/2},{dim/2}],k@@IdentityMatrix[dim/2],
          List];
      J2=Inner[Join,k@@(-IdentityMatrix[dim/2]),k@@Table[0,{dim/2},{dim/2}],
          List];
      SetTensorValueRules[
        Tensor[J,flavor/@{Global`\[Mu],Global`\[Nu]},{Void,Void}],
        Join[J1,J2]]
      ];



TOperator[G_,t_,n_][W_]:=Module[{k},
    NestList[  Hold[ Integrate[PoissonB[G,#],t]]& , W ,
        n].Table[(-1)^k,{k,0,n}]
    ]

InverseTOperator[G_,t_,n_][W_]:=Module[{k},
    NestList[  Hold[ Integrate[PoissonB[G,#],t]]& , W ,
        n].Table[(1)^k,{k,0,n}]
    ]

ExpandedTOperator[{x_,\[Delta]_,g_,\[CapitalGamma]_},J_,G_,t_,n_,
      fla_:Identity][W_]:=
  Module[{k,\[Mu],\[Nu]},
    ExpandedP=
      NondependentPartialD[{x,J}][
          ExpandPoissonB[{x,\[Delta],g,\[CapitalGamma]},
              J,{fla@\[Mu],fla@\[Nu]}][PoissonB[G,#]]]&;
    W+Drop[
          NestList[SumExpansion[{fla@\[Mu],fla@\[Nu]}][ExpandedP[#//Expand]]&,
            W,n],1].Table[(-1)^k*t^k/k!,{k,1,n}]]

ExtractSeriesTerm[\[Epsilon]_,0][expr_]:=expr/.\[Epsilon]->0;
ExtractSeriesTerm[\[Epsilon]_,1][expr_]:=expr/.a_*\[Epsilon]+_->a;
ExtractSeriesTerm[\[Epsilon]_,n_][expr_]:=expr/.{a_*\[Epsilon]^n+_->a};

TOperatorPerturbationExpansion[G_,W_,\[Epsilon]_,n_?IntegerQ]:=Module[{},
    Collect[
      Expand[TOperator[
              GeneratorPerturbationExpansion[G,\[Epsilon],2],\[Epsilon],n][
            W]/.Hold\[Rule]Identity]
      ,\[Epsilon]]]

InverseTOperatorPerturbationExpansion[G_,W_,\[Epsilon]_,n_?IntegerQ]:=
  Module[{},
    Collect[
      Expand[InverseTOperator[
              GeneratorPerturbationExpansion[G,\[Epsilon],2],\[Epsilon],n][
            W]/.Hold\[Rule]Identity]
      ,\[Epsilon]]]

GeneratorPerturbationExpansion[G_,\[Epsilon]_,n_?IntegerQ]:=
  Plus@@(Part[#,2]*Tensor[G,{Void},{Part[#,1]}]&/@
        Table[{i,\[Epsilon]^(i-1)},{i,1,n}])

HamiltonianPerturbationExpansion[K_,\[Epsilon]_,n_?IntegerQ]:=
  Plus@@(Part[#,2]*Tensor[K,{Void},{Part[#,1]}]&/@
        Table[{i,\[Epsilon]^i},{i,0,n}])



End[]

EndPackage[]