(************** Content-type: application/mathematica **************
                     CreatedBy='Mathematica 4.2'

                    Mathematica-Compatible Notebook

This notebook can be used with any Mathematica-compatible
application, such as Mathematica, MathReader or Publicon. The data
for the notebook starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do
one of the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the
  application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing
the word CacheID, otherwise Mathematica-compatible applications may
try to use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
*******************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[     25155,        656]*)
(*NotebookOutlinePosition[     25839,        679]*)
(*  CellTagsIndexPosition[     25795,        675]*)
(*WindowFrame->Normal*)



Notebook[{

Cell[CellGroupData[{
Cell["Lie Transformations", "Title"],

Cell["\<\
Renan Cabrera
rencabla@ceibo.entelnet.bo
2003\
\>", "Subsubtitle"],

Cell[TextData[{
  "We can generate a variation from a transformation given the Hamiltonian, \
the angular momentum or the linear momentum. We can apply a continuous \
composition of variations to get a finite continuous transformation. It is \
not very difficult to obtain the following  operator of the accumulative \
effect of infinitesimal canonical transformations generated by ",
  Cell[BoxData[
      \(G\)]],
  " in the parameter ",
  Cell[BoxData[
      \(\[Epsilon]\)]],
  ". "
}], "Text"],

Cell[BoxData[
    RowBox[{
      StyleBox["T",
        FontSize->16,
        FontWeight->"Bold",
        FontSlant->"Italic"], 
      "=", \(\[ExponentialE]\^\(-\(\[Integral]{\(G\)\(,\)\ \ \ \ } \
\[DifferentialD]\[Epsilon]\)\)\)}]], "Text",
  TextAlignment->Center,
  TextJustification->0,
  FontSize->18],

Cell["\<\
where the empty space in the Poisson Bracket is a free slot to be applied to \
the function operated on. The exponential is not the exponential of a \
function but instead the exponential of a differential operator, which is \
really defined by the corresponding infinite series expansion. \
\>", "Text"],

Cell[TextData[{
  "In general if the Generator depends on the parameter of expansion ",
  Cell[BoxData[
      \(\[Epsilon]\)]],
  " the series expansion of the transformation operator is:"
}], "Text"],

Cell[BoxData[
    RowBox[{
      StyleBox["T",
        FontSize->16,
        FontWeight->"Bold",
        FontSlant->"Italic"], "=", 
      RowBox[{
        SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", 
            RowBox[{"\[Integral]", 
              RowBox[{
                RowBox[{"{", 
                  RowBox[{
                    SubsuperscriptBox["G", 
                      InterpretationBox["\[Epsilon]",
                        SequenceForm[ \[Epsilon]],
                        Editable->False], 
                      InterpretationBox[
                        TagBox[
                          StyleBox["\[Epsilon]",
                            ShowContents->False],
                          (StyleForm[ #, ShowContents -> False]&)],
                        SequenceForm[ 
                          StyleForm[ \[Epsilon], ShowContents -> False]],
                        Editable->False]], ","}], "    ", 
                  "}"}], \(\[DifferentialD]\[Epsilon]\)}]}]}]], "=", 
        RowBox[{
          RowBox[{"1", "+", 
            RowBox[{"\[Integral]", 
              RowBox[{
                FormBox[
                  TagBox[
                    RowBox[{"{", 
                      RowBox[{
                        FormBox[
                          InterpretationBox[
                            SubsuperscriptBox["G", 
                              InterpretationBox["\[Epsilon]",
                                SequenceForm[ \[Epsilon]],
                                Editable->False], 
                              InterpretationBox[
                                TagBox[
                                  StyleBox["\[Epsilon]",
                                    ShowContents->False],
                                  (StyleForm[ #, ShowContents -> False]&)],
                                SequenceForm[ 
                                  StyleForm[ \[Epsilon], ShowContents -> 
                                    False]],
                                Editable->False]],
                            Subsuperscript[ G, 
                              SequenceForm[ \[Epsilon]], 
                              SequenceForm[ 
                                
                                StyleForm[ \[Epsilon], ShowContents -> 
                                  False]]],
                            Editable->False],
                          "TraditionalForm"], ","}], " ", "}"}],
                    DisplayForm],
                  "TraditionalForm"], \(\[DifferentialD]\[Epsilon]\)}]}], "+",
             
            RowBox[{"\[Integral]", 
              RowBox[{
                FormBox[
                  TagBox[
                    RowBox[{"{", 
                      FormBox[
                        InterpretationBox[
                          SubsuperscriptBox["G", 
                            InterpretationBox["\[Epsilon]",
                              SequenceForm[ \[Epsilon]],
                              Editable->False], 
                            InterpretationBox[
                              TagBox[
                                StyleBox["\[Epsilon]",
                                  ShowContents->False],
                                (StyleForm[ #, ShowContents -> False]&)],
                              SequenceForm[ 
                                
                                StyleForm[ \[Epsilon], ShowContents -> 
                                  False]],
                              Editable->False]],
                          Subsuperscript[ G, 
                            SequenceForm[ \[Epsilon]], 
                            SequenceForm[ 
                              StyleForm[ \[Epsilon], ShowContents -> False]]],
                          
                          Editable->False],
                        "TraditionalForm"], ",", 
                      RowBox[{"\[Integral]", 
                        RowBox[{
                          FormBox[
                            TagBox[
                              RowBox[{"{", 
                                RowBox[{
                                  FormBox[
                                    InterpretationBox[
                                      SubsuperscriptBox["G", 
                                        InterpretationBox["\[Epsilon]",
                                        SequenceForm[ \[Epsilon]],
                                        Editable->False], 
                                        InterpretationBox[
                                        TagBox[
                                        StyleBox["\[Epsilon]",
                                        ShowContents->False],
                                        (
                                        StyleForm[ #, ShowContents -> 
                                        False]&)],
                                        SequenceForm[ 
                                        
                                        StyleForm[ \[Epsilon], ShowContents -> 
                                        False]],
                                        Editable->False]],
                                      Subsuperscript[ G, 
                                        SequenceForm[ \[Epsilon]], 
                                        SequenceForm[ 
                                        
                                        StyleForm[ \[Epsilon], ShowContents -> 
                                        False]]],
                                      Editable->False],
                                    "TraditionalForm"], ","}], " ", "}"}],
                              DisplayForm],
                            
                            "TraditionalForm"], \
\(\[DifferentialD]\[Epsilon]\)}]}], "}"}],
                    DisplayForm],
                  "TraditionalForm"], \(\[DifferentialD]\[Epsilon]\)}]}], "+",
             
            TagBox[
              StyleBox[
                RowBox[{
                  RowBox[{"\[Integral]", 
                    RowBox[{
                      FormBox[
                        TagBox[
                          RowBox[{"{", 
                            FormBox[
                              InterpretationBox[
                                SubsuperscriptBox["G", 
                                  InterpretationBox["\[Epsilon]",
                                    SequenceForm[ \[Epsilon]],
                                    Editable->False], 
                                  InterpretationBox[
                                    TagBox[
                                      StyleBox["\[Epsilon]",
                                        ShowContents->False],
                                      (
                                      StyleForm[ #, ShowContents -> False]&)],
                                    
                                    SequenceForm[ 
                                      
                                      StyleForm[ \[Epsilon], ShowContents -> 
                                        False]],
                                    Editable->False]],
                                Subsuperscript[ G, 
                                  SequenceForm[ \[Epsilon]], 
                                  SequenceForm[ 
                                    
                                    StyleForm[ \[Epsilon], ShowContents -> 
                                      False]]],
                                Editable->False],
                              "TraditionalForm"], ",", 
                            RowBox[{"\[Integral]", 
                              RowBox[{
                                FormBox[
                                  TagBox[
                                    RowBox[{"{", 
                                      FormBox[
                                        InterpretationBox[
                                        SubsuperscriptBox["G", 
                                        InterpretationBox["\[Epsilon]",
                                        SequenceForm[ \[Epsilon]],
                                        Editable->False], 
                                        InterpretationBox[
                                        TagBox[
                                        StyleBox["\[Epsilon]",
                                        ShowContents->False],
                                        (
                                        StyleForm[ #, ShowContents -> 
                                        False]&)],
                                        SequenceForm[ 
                                        
                                        StyleForm[ \[Epsilon], ShowContents -> 
                                        False]],
                                        Editable->False]],
                                        Subsuperscript[ G, 
                                        SequenceForm[ \[Epsilon]], 
                                        SequenceForm[ 
                                        
                                        StyleForm[ \[Epsilon], ShowContents -> 
                                        False]]],
                                        Editable->False],
                                        "TraditionalForm"], ",", 
                                      RowBox[{"\[Integral]", 
                                        RowBox[{
                                        FormBox[
                                        TagBox[
                                        RowBox[{"{", 
                                        RowBox[{
                                        FormBox[
                                        InterpretationBox[
                                        SubsuperscriptBox["G", 
                                        InterpretationBox["\[Epsilon]",
                                        SequenceForm[ \[Epsilon]],
                                        Editable->False], 
                                        InterpretationBox[
                                        TagBox[
                                        StyleBox["\[Epsilon]",
                                        ShowContents->False],
                                        (StyleForm[ #, ShowContents -> 
                                        False]&)],
                                        SequenceForm[ 
                                        
                                        StyleForm[ \[Epsilon], ShowContents -> 
                                        False]],
                                        Editable->False]],
                                        Subsuperscript[ G, 
                                        SequenceForm[ \[Epsilon]], 
                                        SequenceForm[ 
                                        
                                        StyleForm[ \[Epsilon], ShowContents -> 
                                        False]]],
                                        Editable->False],
                                        "TraditionalForm"], ","}], " ", "}"}],
                                        
                                        DisplayForm],
                                        
                                        "TraditionalForm"], \
\(\[DifferentialD]\[Epsilon]\)}]}], "}"}],
                                    DisplayForm],
                                  
                                  "TraditionalForm"], \(\[DifferentialD]\
\[Epsilon]\)}]}], "}"}],
                          DisplayForm],
                        
                        "TraditionalForm"], \
\(\[DifferentialD]\[Epsilon]\)}]}], "+"}],
                FontFamily->"Courier",
                FontSize->16],
              (StyleForm[ #, FontSize -> 16, FontFamily -> "Courier"]&)]}], 
          "..."}]}]}]], "Text",
  TextAlignment->Left,
  TextJustification->0,
  FontSize->18],

Cell["\<\
and again the empty space in the Poisson bracket represents the part where \
the function to operate on must be plugged in.\
\>", "Text"],

Cell[CellGroupData[{

Cell["Initialization.", "Subsection"],

Cell[BoxData[{
    \(Needs["\<TensorCalculus3`Tensorial`\>"]\), "\[IndentingNewLine]", 
    \(Needs["\<TMecanica1`TMecanica`\>"]\)}], "Input"],

Cell[TextData[{
  "Initializing a 2D system with coordinates ",
  Cell[BoxData[
      \({x, p}\)]]
}], "Text"],

Cell[BoxData[{
    \(DeclareBaseIndices[{x, p}]\), "\[IndentingNewLine]", 
    \(DefineTensorShortcuts[{{\[Xi], x}, 1}, {{\[Delta], J}, 
        2}]\), "\[IndentingNewLine]", 
    \(\(labs = {\[Xi], \[Delta], 
          g, \[CapitalGamma]};\)\), "\[IndentingNewLine]", 
    \(\(SetTensorValues[\[Delta]ud[i, j], 
        IdentityMatrix[NDim]];\)\), "\[IndentingNewLine]", 
    \(SetSymplecticJValues[J, NDim]\)}], "Input"],

Cell["\<\
The transformation operator up to the nth order in the series expansion is \
given by the following function.\
\>", "Text"],

Cell[BoxData[
    \(\(?TOperator\)\)], "Input"],

Cell["\<\
T expanded up to the third order, if the generator does not depend on the \
expansion parameter, is:\
\>", "Text"],

Cell[BoxData[
    \(\(TOperator[Tensor[G], \[Epsilon], 4]\)[\ \ Tensor[W]] /. 
      Hold \[Rule] Identity\)], "Input"],

Cell["\<\
Using  ExpandedTOperator to make a full expansion in terms of partial \
derivatives.\
\>", "Text"],

Cell[BoxData[
    \(\(?ExpandedTOperator\)\)], "Input"],

Cell[BoxData[
    \(\(ExpandedTOperator[{x, \[Delta], g, \[CapitalGamma]}, J, Tensor[G], t, 
        2]\)[Tensor[W]]\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["The Evolution Operator with the Hamiltonian as Generator", "Subsection"],

Cell[TextData[{
  "Using the Hamiltonian, ",
  Cell[BoxData[
      \(H\)]],
  ", as the generator, the ",
  Cell[BoxData[
      \(T\)]],
  " operator becomes just the evolution operator. Taking just the first order \
term of the evolution we have:"
}], "Text"],

Cell[BoxData[
    \(\(ExpandedTOperator[{x, \[Delta], g, \[CapitalGamma]}, J, Tensor[H], 
        dt, 1]\)[\ \ F[xu[x], xu[p]]]\)], "Input"],

Cell["\<\
It is easier to interpret this result using the Hamilton equations to replace \
the respective derivatives of the Hamiltonian.\
\>", "Text"],

Cell[BoxData[
    \(HE2D = {\(PartialD[{x, \[Delta], g, \[CapitalGamma]}]\)[Tensor[H], 
            xu[p]] \[Rule] 
          TotalD[xu[x], t], \(PartialD[{x, \[Delta], g, \[CapitalGamma]}]\)[
            Tensor[H], xu[x]] \[Rule] \(-TotalD[xu[p], t]\)}\)], "Input"],

Cell["Repeating the calculation and using the substitutions,", "Text"],

Cell[BoxData[{
    \(\(ExpandedTOperator[{x, \[Delta], g, \[CapitalGamma]}, J, Tensor[H], 
          dt, 1]\)[\ \ F[xu[x], xu[p]]\ \ ] /. 
      HE2D\), "\[IndentingNewLine]", 
    \(% // Simplify\)}], "Input"],

Cell["which is just a truncated Taylor series.", "Text"],

Cell["\<\
Starting over again, but letting F to be the Hamiltonian itself.\
\>", "Text"],

Cell[BoxData[{
    \(\(ExpandedTOperator[{x, \[Delta], g, \[CapitalGamma]}, J, Tensor[H], 
        dt, 1]\)[\ \ F[xu[x], xu[p]]\ \ ]\), "\[IndentingNewLine]", 
    \(% /. Tensor[H] \[Rule] F[xu[x], xu[p]]\)}], "Input"],

Cell["\<\
Oh! it is the same; the evolution operator does not take effect. Of course \
the Hamiltonian is invariant under the evolution operator. We say that the \
Hamiltonian is an integral of motion.\
\>", "Text",
  TextAlignment->Left,
  TextJustification->1],

Cell["\<\
The evolution operator applied to the coordinates generates the trajectories \
in the phase space; of course they are not invariant.\
\>", "Text",
  TextAlignment->Left,
  TextJustification->1],

Cell[BoxData[{
    \(ClearTensorValues[Tensor[H]]\), "\[IndentingNewLine]", 
    \(\(ExpandedTOperator[{x, \[Delta], g, \[CapitalGamma]}, J, Tensor[H], 
        dt, 1]\)[\ \ xu[\[Mu]]\ \ ]\), "\[IndentingNewLine]", 
    \(% // ToArrayValues[]\), "\[IndentingNewLine]", 
    \(% /. {\(PartialD[{x, \[Delta], g, \[CapitalGamma]}]\)[Tensor[K], 
            xu[p]] \[Rule] 
          TotalD[xu[x], t], \(PartialD[{x, \[Delta], g, \[CapitalGamma]}]\)[
            Tensor[K], xu[x]] \[Rule] \(-TotalD[xu[p], t]\)}\)}], "Input"],

Cell[TextData[{
  "The usual interpretation says that this is the trajectory with the initial \
values ",
  Cell[BoxData[
      FormBox[
        SubsuperscriptBox["x", 
          InterpretationBox[
            TagBox[
              StyleBox["x",
                ShowContents->False],
              (StyleForm[ #, ShowContents -> False]&)],
            SequenceForm[ 
              StyleForm[ x, ShowContents -> False]],
            Editable->False], 
          InterpretationBox["x",
            SequenceForm[ x],
            Editable->False]], TraditionalForm]]],
  " and ",
  Cell[BoxData[
      FormBox[
        FormBox[
          InterpretationBox[
            SubsuperscriptBox["x", 
              InterpretationBox[
                TagBox[
                  StyleBox["p",
                    ShowContents->False],
                  (StyleForm[ #, ShowContents -> False]&)],
                SequenceForm[ 
                  StyleForm[ p, ShowContents -> False]],
                Editable->False], 
              InterpretationBox["p",
                SequenceForm[ p],
                Editable->False]],
            Subsuperscript[ x, 
              SequenceForm[ 
                StyleForm[ p, ShowContents -> False]], 
              SequenceForm[ p]],
            Editable->False],
          "TraditionalForm"], TraditionalForm]]],
  ". A more productive point of view of this result says that the Hamiltonian \
is the generator of a canonical transformations with a parameter t. In this \
case the trajectory can be found by projecting all the possible values of the \
coordinates into a single space."
}], "Text",
  TextAlignment->Left,
  TextJustification->1],

Cell["\<\
Risking overstatement, we can say that a conserved quantity (integral of \
motion) works as a generator of a canonical transformation where this \
transformation is continuous and parametrized.\
\>", "Text"],

Cell["Summarizing:", "Text"],

Cell[TextData[{
  "\[FilledSmallSquare] ",
  StyleBox["If the Hamiltonian is an invariant scalar tensor the following is \
true by principle.",
    FontWeight->"Bold"],
  "\n\t\t\t\tH = K(\[Eta]) = H(\[Xi])\nwhere we write H without any argument \
to represent the abstract scalar tensor. H(\[Xi]) and  K(\[Eta]) are the \
functions representing the Hamiltonian in the old and new system. \[Xi] are \
the coordinates in the old system and \[Eta] the coordinates in the new \
system.\n\n\[FilledSmallSquare] ",
  StyleBox["The action of the evolution operator is to change the \
coordinates.",
    FontWeight->"Bold"],
  "\n\t\t\t\t\[Eta] = ",
  StyleBox["T",
    FontWeight->"Bold",
    FontSlant->"Italic"],
  " \[Xi]\nThe action of the evolution operator on an arbitrary function is \
then:\n\t\t\t\t",
  StyleBox["T",
    FontWeight->"Bold",
    FontSlant->"Italic"],
  " F(\[Xi]) = F(",
  Cell[BoxData[
      StyleBox[
        SuperscriptBox[
          StyleBox["T",
            FontSize->16,
            FontSlant->"Italic"], \(\(\ \)\(-1\)\)],
        FontSize->16]]],
  "\[Xi] ) \n\t\t\t\t\t \n\[FilledSmallSquare] ",
  StyleBox["If the Hamiltonian is an integral of motion (remains the same in \
time) the following is true.",
    FontWeight->"Bold"],
  "\n\t\t\t\t",
  StyleBox["T",
    FontWeight->"Bold",
    FontSlant->"Italic"],
  " H(\[Xi]) = H(\[Xi])\nAnd the following is also true.\n\t\t\t\tH(\[Eta]) = \
H(\[Xi])"
}], "EmphasisText"],

Cell[TextData[{
  "Home Work: Can you prove",
  StyleBox[" T",
    FontWeight->"Bold",
    FontSlant->"Italic"],
  " F(\[Xi]) = F(",
  Cell[BoxData[
      StyleBox[
        SuperscriptBox[
          StyleBox["T",
            FontSize->16,
            FontSlant->"Italic"], \(\(\ \)\(-1\)\)],
        FontSize->16]]],
  "\[Xi] )  for a particular case where the difference between the \
coordinates is infinitesimal and parametrized by \[Epsilon]?"
}], "Text"]
}, Closed]],

Cell[CellGroupData[{

Cell["A Particle Subject to a Constant Acceleration.", "Subsection"],

Cell[TextData[{
  "Let's use the Hamiltonian ",
  Cell[BoxData[
      \(Q\)]],
  " corresponding to a particle subject to a constant acceleration ",
  Cell[BoxData[
      \(a\)]],
  ". "
}], "Text"],

Cell[BoxData[{
    \(\(SetTensorValueRules[
        Tensor[Q], \[Xi]u[p]\^2/\((2  m)\) - 
          m\ a\ \[Xi]u[x]\ ];\)\), "\[IndentingNewLine]", 
    \(\(Attributes[a] = {Constant};\)\), "\[IndentingNewLine]", 
    \(\(Attributes[m] = {Constant};\)\), "\[IndentingNewLine]", 
    \(TensorValueRules[Q]\)}], "Input"],

Cell["\<\
 Applying the evolution operator over the coordinates up to the second order \
we have:\
\>", "Text"],

Cell[BoxData[{
    \(\(ExpandedTOperator[{\[Xi], \[Delta], g, \[CapitalGamma]}, J, 
          Tensor[Q], t, 2]\)[\ \[Xi]u[i]] /. 
      TensorValueRules[Q]\), "\[IndentingNewLine]", 
    \(% // ToArrayValues[]\)}], "Input"],

Cell["\<\
This expansion is exact because all the remaining higher orders are zero. \
Trying a third order expansion we get the same result.\
\>", "Text"],

Cell[BoxData[{
    \(\(ExpandedTOperator[{\[Xi], \[Delta], g, \[CapitalGamma]}, J, 
          Tensor[Q], t, 3]\)[\ \[Xi]u[i]] /. 
      TensorValueRules[Q]\), "\[IndentingNewLine]", 
    \(traject = % // ToArrayValues[]\)}], "Input"],

Cell["\<\
Of course the answer is easy to identify as correct. We found the solution of \
the trajectories without solving a differential equation! But with this \
method the evolution of the coordinates is only a particular case.\
\>", "Text"],

Cell["\<\
Finally let's see if the Hamiltonian really remains invariant.\
\>", "Text"],

Cell[BoxData[{
    \(Tensor[Q] /. TensorValueRules[Q]\), "\[IndentingNewLine]", 
    \(% /. Thread[{\[Xi]u[x], \[Xi]u[p]} \[Rule] 
          traject]\), "\[IndentingNewLine]", 
    \(% // Expand\)}], "Input"]
}, Closed]]
}, Open  ]]
},
FrontEndVersion->"4.2 for Microsoft Windows",
ScreenRectangle->{{0, 1280}, {0, 943}},
WindowSize->{792, 500},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
StyleDefinitions -> "TensorialStyle.nb"
]

(*******************************************************************
Cached data follows.  If you edit this Notebook file directly, not
using Mathematica, you must remove the line containing CacheID at
the top of  the file.  The cache data will then be recreated when
you save this file from within Mathematica.
*******************************************************************)

(*CellTagsOutline
CellTagsIndex->{}
*)

(*CellTagsIndex
CellTagsIndex->{}
*)

(*NotebookFileOutline
Notebook[{

Cell[CellGroupData[{
Cell[1776, 53, 36, 0, 76, "Title"],
Cell[1815, 55, 76, 4, 79, "Subsubtitle"],
Cell[1894, 61, 498, 12, 74, "Text"],
Cell[2395, 75, 306, 10, 39, "Text"],
Cell[2704, 87, 314, 5, 74, "Text"],
Cell[3021, 94, 200, 5, 34, "Text"],
Cell[3224, 101, 11931, 242, 104, "Text"],
Cell[15158, 345, 147, 3, 34, "Text"],

Cell[CellGroupData[{
Cell[15330, 352, 37, 0, 49, "Subsection"],
Cell[15370, 354, 142, 2, 66, "Input"],
Cell[15515, 358, 110, 4, 34, "Text"],
Cell[15628, 364, 422, 8, 126, "Input"],
Cell[16053, 374, 133, 3, 34, "Text"],
Cell[16189, 379, 47, 1, 46, "Input"],
Cell[16239, 382, 124, 3, 34, "Text"],
Cell[16366, 387, 119, 2, 46, "Input"],
Cell[16488, 391, 108, 3, 34, "Text"],
Cell[16599, 396, 55, 1, 46, "Input"],
Cell[16657, 399, 129, 2, 46, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[16823, 406, 78, 0, 33, "Subsection"],
Cell[16904, 408, 260, 9, 54, "Text"],
Cell[17167, 419, 140, 2, 46, "Input"],
Cell[17310, 423, 150, 3, 34, "Text"],
Cell[17463, 428, 266, 4, 66, "Input"],
Cell[17732, 434, 70, 0, 34, "Text"],
Cell[17805, 436, 210, 4, 66, "Input"],
Cell[18018, 442, 56, 0, 34, "Text"],
Cell[18077, 444, 88, 2, 34, "Text"],
Cell[18168, 448, 218, 3, 66, "Input"],
Cell[18389, 453, 262, 6, 54, "Text"],
Cell[18654, 461, 203, 5, 34, "Text"],
Cell[18860, 468, 521, 8, 126, "Input"],
Cell[19384, 478, 1669, 46, 75, "Text"],
Cell[21056, 526, 217, 4, 54, "Text"],
Cell[21276, 532, 28, 0, 34, "Text"],
Cell[21307, 534, 1451, 40, 328, "EmphasisText"],
Cell[22761, 576, 459, 15, 55, "Text"]
}, Closed]],

Cell[CellGroupData[{
Cell[23257, 596, 68, 0, 33, "Subsection"],
Cell[23328, 598, 198, 8, 34, "Text"],
Cell[23529, 608, 318, 6, 106, "Input"],
Cell[23850, 616, 111, 3, 34, "Text"],
Cell[23964, 621, 223, 4, 66, "Input"],
Cell[24190, 627, 154, 3, 34, "Text"],
Cell[24347, 632, 233, 4, 66, "Input"],
Cell[24583, 638, 244, 4, 54, "Text"],
Cell[24830, 644, 86, 2, 34, "Text"],
Cell[24919, 648, 208, 4, 86, "Input"]
}, Closed]]
}, Open  ]]
}
]
*)



(*******************************************************************
End of Mathematica Notebook file.
*******************************************************************)

